#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

#define N 2000

double A[N][N], B[N][N], C[N][N];

int main(int argc, char *argv[])
{
  int i, j, k;
  double s;

  // initialize A and B
  for (i=0; i<N; i++)
  {
    for (j=0; j<N; j++)
    {
      A[i][j] = rand();
      B[i][j] = rand();
    }
  }

  // print part of A and B
  printf("%f %f\n", A[0][0], B[0][0]);
  double t1 = omp_get_wtime();
  
  #pragma omp parallel for private(j,k,s) schedule(runtime)
  for (i=0; i<N; i++)
  {
    for (j=0; j<N; j++)
    {
      s = 0;
      for (k=0; k<N; k++)
      {
        s += A[i][k]*B[k][j];
      }
      C[i][j] = s;
    }
  }
  
  // print part of C
  double t2 = omp_get_wtime();
  printf("%f (%f s)\n", C[0][0], t2-t1);
  return 0;
}

