#include <stdlib.h>
#include <stdio.h>
#include <omp.h>

int compute(int*a, int begin, int end);
int f(int);

int main(int argc, char* argv[])
{
  #pragma omp parallel
  {
  #pragma omp single
    {
      int n = 1000000;
      int* a = malloc(n*sizeof(int));
      double start = omp_get_wtime();
      int r = compute(a, 0, n-1);
      double end = omp_get_wtime();
      printf("%d (%d ms)\n", r, (int)((end-start)*1000));
    }
  }
}

int compute(int* a, int begin, int end)
{
  int n = end-begin;
  if (n < 0) return 0;
  if (n == 1) return f(begin);
  int mid = (begin+end)/2;
  int r1, r2;
  #pragma omp task shared(r1)
  r1 = compute(a, begin, mid);
  #pragma omp task shared(r2)
  r2 = compute(a, mid, end);
  #pragma omp taskwait
  return r1+r2;
}

int f(int x)
{
  for (int i=0; i<100000; i++) x = -x;
  return x;
}
